BEGIN
{
    push(@INC, '/home/elwood/src/perl/GSM');
    push(@INC, '/home/elwood/src/perl/GSM/GSMD/Gnokii/blib/arch');
    push(@INC, '/home/elwood/src/perl/GSM/GSMD/Gnokii/blib/lib');
}

use GSMI;
use Data::Dumper;


my $conn = GSMI->connect("driver=Gnokii;device=/dev/ircomm0;options=model:6310,connection:infrared,initlengh:1");
#my $conn = GSMI->connect("driver=Gnokii;device=/dev/ttyS1;options=model:6150,connection:infrared,initlengh:default");
#my $conn = GSMI->connect("driver=Gnokii;device=/dev/ttyS0;options=model:6310,connection:dlr3p,initlength:1");
my $hash = {};
my $imei = $conn->GetIMEI($hash);
#my $imei = $conn->GetIMEI($hash);
print "Identity\n";
print Dumper($hash);
my $ret = $conn->SetSpeedDial(4, 5, "ME");
$ret? print "Error $ret\n" : print "OK\n";


$array = [];
print "SMSCenter\n";
if($ret = $conn->GetSMSCenter(1, 4, $array))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($array);
}
$hash = {};
print "GetAlarm\n";
if($ret = $conn->GetAlarm($hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}
$hash = {};
print "GetRF\n";
if($ret = $conn->GetRF($hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}
my $bhash = {};
print "GetMemoryStatus\n";
if($ret = $conn->GetMemoryStatus($bhash))
{
    print "Error: $ret\n";
}
print Dumper($bhash);
$hash = {};
print "GetPowerStats\n";
$|=1;
if($ret = $conn->GetPowerStats($hash))
{
    print "Error: $ret\n";
}
print Dumper($hash);
$hash = {};
print "GetSMSSTatus\n";
if($ret = $conn->GetSMSStatus($hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}
$hash = {};
print "GetNetworkInfo\n";
if($ret = $conn->GetNetworkInfo($hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}
exit(0);



my $array = [];

my $phash = 
{
    'location' => 99,
    'number' => '+4912345',
    'callergroup' => 0,
    'name' => 'GSMTEST',
    'memorytype' => 'SM'
};

my $ret = $conn->WritePhonebookEntry($phash);
$ret? print "Error $ret\n" : print "OK\n";


my $calhash = 
{
    'text' => 'ElwoodTest',
    'date' => time(),
    'type' => 'call',
    'number' => '12345',
    'recurrence' => 'never'
};

my $ret = $conn->WriteCalendarNote(10, $calhash);
$ret? print "Error $ret\n" : print "OK\n";


print "Calendar\n";
if($ret = $conn->GetCalendarNote(1,4,$array))
{
    print "Error ";
    $conn->PrintError($ret);
    print Dumper($array);
}
else
{
    print Dumper($array);
}


my $ret = $conn->DeleteAllTodos();
$ret? print "Error $ret\n" : print "OK\n";


my $hash = {
    'text' => 'ElwoodTest',
    'priority' => 'medium'
};
my $ret = $conn->WriteTodo($hash);
if($ret)
{
    print "Error: $ret\n";
    print Dumper($hash);
}
else
{
    print Dumper($hash);
}
my $ret = $conn->SetAlarm(time()+60);
print Dumper($result)."\n$ret\n";

my $ret = $conn->CreateSMSFolder("Elwood");
$ret? print "Error $ret\n" : print "OK\n";

my $result = {};
my $ret = $conn->GetSpeedDial(2, $result);
print Dumper($result)."\n$ret\n";

my $ret = $conn->SetSpeedDial(1, 6, "ME");
$ret? print "Error $ret\n" : print "OK\n";


my $waphash = {
          'gsm_data_authentication' => 'normal',
          'password' => '',
          'smsservicenumber' => '',
          'number' => '+491722290100',
          'name' => 'ElwoodWAP',
          'ip' => '',
          'gprs_connection' => 'when needed',
          'smsservernumber' => '',
          'session' => 'permanent',
          'bearer' => 'GSM data',
          'gsm_data_username' => 'D2',
          'location' => 4,
          'call_speed' => '9600',
          'gprs_login' => 'automatic',
          'gsm_data_login' => 'automatic',
          'call_type' => 'ISDN',
          'home' => 'http://d2wap.de',
          'username' => '',
          'apn' => '',
          'gsm_data_password' => 'wap',
          'gprs_authentication' => 'normal',
          'gsm_data_ip' => '139.7.29.1'
};
my $ret = $conn->WriteWapSetting(4,$waphash);
if($ret)
{
    print "Error: $ret\n";
}
else
{
    print "Success\n";
    print Dumper($waphash);
}


my $ret = $conn->DeleteWapBookmark(8);
$ret? print "Error $ret\n" : print "OK\n";

my $ret = $conn->ActivateWapSetting(4);
$ret? print "Error $ret\n" : print "OK\n";

$waphash = {};
$waphash->{'name'} = "ElwoodTest";
$waphash->{'url'} = "http://www.eplus.de";
#my $ret = $conn->WriteWapBookmark($waphash);
if($ret)
{
    print "Error: $ret\n";
}
else
{
    print "Success\n";
}
print Dumper($waphash);


#my $ret = $conn->SetDateTime(time());
$ret? print "Error $ret\n" : print "OK\n";
sleep(5);
#my $ret = $conn->GetProfile(1,4,$array);
if($ret)
{
    print "Error: $ret\n";
    print Dumper($array) if($ret == 16);
}
else
{
    print Dumper($array);
}


my $ret = $conn->GetTodo(1,4,$array);
if($ret)
{
    print "Error: $ret\n";
    print Dumper($array) if($ret == 16);
}
else
{
    print Dumper($array);
}


my $waphash = {};
#my $ret = $conn->GetWapSetting(1,$waphash);
if($ret)
{
    print "Error: $ret\n";
}
else
{
    print "Success\n";
    print Dumper($waphash);
}

my $ret = $conn->GetWapBookmark(1,$waphash);
if($ret)
{
    print "Error: $ret\n";
}
else
{
    print "Success\n";
    print Dumper($waphash);
}


my $smshash = {};
$smshash->{'destination'} =  '01728986330';
$smshash->{"smscnumber"} = '+491722270333';;
$smshash->{'message'} = "Hello a GSMDTest";
print "Sending SMS\n";
if($ret = $conn->SendSMS($smshash))
{
    print "Error: $ret\n";
}
else
{
    print "Success\n";
}

$array = [];
sleep(10);
print "Calendar\n";
if($ret = $conn->GetCalendarNote(1,1,$array))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($array);
}
$time = {};
print "DateTime\n";
if($ret = $conn->GetDateTime($time))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($time);
}
#$phonebookhash = $conn->get_phonebook_entry("ME", 5, $array);
#print "Press enter to continue";
#my $enter = <STDIN>;
#sleep(5);

print "SpeedDial\n";
if($ret = $conn->GetSpeedDial(2, $hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}

$array= [];
print "Phonebook: \n";
if($ret = $conn->ReadPhonebook("SM", 1, 1, $array))
{
    print "Error $ret\n";
}
else
{
    print Dumper($array);
}

#exit(0);
$hash = {};
print "GetSMS:\n";
if($ret = $conn->GetSMS("IN", 1, $hash))
{
    print "Error $ret\n";
}
else
{
    print Dumper($hash);
}
$hash = {};
$logodata->{'type'} = 'op';
print "Logo\n";
if($ret = $conn->GetLogo($logodata, $hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}
$hash={};
print "RingTone\n";
if($ret = $conn->GetRingTone(1, $hash))
{
    print "Error: $ret\n";
}
else
{
    print Dumper($hash);
}

$conn->disconnect();
exit(0);
#my $conn = GSMI->connect("device=/dev/ircomm0;options=model:6310,conn:IRDA");
